'use strict';

/* Services */


// Demonstrate how to register services
// In this case it is a simple value service.
angular.module('myApp.services', []).
factory('myService', ['$q','$rootScope','$timeout', function($q,$rootScope,$timeout) {
                      
                      var factory = {};
                      
                      factory.isReaderConnected = false;
					  factory.readerStatus = 'Connect';
                      factory.modalActivated = false;
					  factory.isUnsupported = false;
                      //factory.height = function() { return $(window).height();};
                      //factory.width = function() { return $(window).width();};
                      
					  factory.setReaderStatus = function(status)
					  {
						factory.readerStatus = status;
						$rootScope.$broadcast('reader:updated');
					  }
                      
                      factory.activateSDK = function() {
						  if(!factory.isReaderConnected)
						  {
							  //activate sdk and register notification callback
							  //these receive all notifCallbacks from plugin: ie
							  //type == "Activated" --> notifCallback.pluginResult(PluginResult.Status.OK, "Activated")
							  unimag.activateSDK(function(type) {
												 console.log('UniMag: ' + type);

												 if(type == 'Activated')
												 {
													factory.connectSDK();
												 }
												 else if(type == 'Deactivated')
												 {
													factory.deactivateSDK();
												 }
												 else if(type == 'E_timeout')
												 {
													navigator.notification.alert('Reader timed out. Try turning up the media volume on your phone to MAX.',null,'!','Okay');
												 }
												 else if(type == 'E_failure')
												 {
													navigator.notification.alert('Card reader not supported on this device. Feel free to contact customer support for more information. 1-888-414-7111',null,'!','Okay');
													factory.isUnsupported = true;
												 }
												 });
							  //$window.alert('test');
						  }
                      };
                      
                      factory.deactivateSDK = function() {
                      //deactivate sdk and unregister notification callback
                      unimag.stopTask();
                      unimag.deactivateSDK();
                      factory.isReaderConnected = false;
					  factory.setReaderStatus('Connect');
					  
					  var swipeElement = document.getElementById('btnSwipe');
					  if(swipeElement)
					  {
						  swipeElement.disabled = true;
						  swipeElement.style.background = "#BEC5CC";
						  swipeElement.style.color = "gray";
						  swipeElement.style.border = "1px solid #BEC5CC";
						  swipeElement.style.opacity = "0.5";
					  }
                      
                      };
                      
                      factory.connectSDK = function() {
                      unimag.startTaskConnect(function(task, taskNotif, info) {
                                              var E = unimag.TaskNotifEnum;
											  console.log('xxx task: ' + task + ' xxx taskNotif: ' + taskNotif + ' xxx info: ' + info);
                                              switch(taskNotif) {
                                              case E.Started:
                                              console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                              break;
                                              case E.Update:
                                              console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
											  factory.setReaderStatus('Connecting..');
                                              break;
                                              case E.StartFailed:
                                              console.log("Task Failed: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
											  navigator.notification.alert(info.message,null,'!','Okay');
											  factory.setReaderStatus('Connect');
											  factory.isReaderConnected = false;
                                              break;
                                              case E.Stopped:
                                              console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                              factory.isReaderConnected = true;
											  factory.setReaderStatus('Disconnect');
                                              var swipeElement = document.getElementById('btnSwipe');
                                              if(swipeElement)
                                              {
                                              swipeElement.disabled = false;
                                              swipeElement.style.background = "#a0c6e6";
                                              swipeElement.style.color = "#fff";
                                              swipeElement.style.border = "1px solid #a0c6e6";
                                              swipeElement.style.opacity = "1.0";
                                              }
                                              var toggleElement = document.getElementById('btnToggleReader');
                                              if(toggleElement)
                                              {
                                                toggleElement.disabled = false;
                                              }
                                              break;
                                              }
                                              });
                      }
                      
                      factory.stopTask = function()
                      {
                      unimag.stopTask();
                      }
                      
                      factory.swipe = function() {
                      var cardInfo = {};
                      var deferred = $q.defer();
                      unimag.startTaskSwipe(function(task, taskNotif, info) {
                                            var E = unimag.TaskNotifEnum;
                                            switch(taskNotif) {
                                            case E.Started:
                                            console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                            //document.getElementById('openModal').style.opacity = 1;
                                            //document.getElementById('openModal').style.pointerEvents = 'auto';
                                            break;
                                            case E.Update:
                                            console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                            
                                            break;
                                            case E.StartFailed:
                                            console.log("Task Failed: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                            break;
                                            case E.Stopped:
                                            var cardFields = "";
                                            if(info.cardData) //handle card data for android
                                            {
                                            cardFields = info.cardData.split("^");
                                            }
                                            else //handle card data for iOS
                                            {
                                            cardFields = getStrRepr(info.data);
                                            cardFields = cardFields.split("^");
                                            }
                                            cardInfo.cardNum = cardFields[0].substring(2,cardFields[0].length);
                                            cardInfo.expMonth = cardFields[2].substring(2,4);
                                            cardInfo.expYear = '20' + cardFields[2].substring(0,2);
                                            var cName = cardFields[1].split("/");
                                            cardInfo.customer = cName[1] + cName[0];
                                            deferred.resolve(cardInfo);
                                            console.log("Task: " + task + " STATUS: " + taskNotif + "...Message: " + info.message);
                                            break;
                                            }
                                            });
                      return deferred.promise;
                      }
                      
                      //get base16 encoded string, given unsigned char (byte) array
                      function getBase16(array) {
                      var ret = [], a = array;
                      for (var i=0; i<a.length; i++) {
                      var hex = a[i].toString(16);
                      ret[i] = (hex.length==1?"0":"")+hex;
                      if (i%4==3)
                      ret[i] += " ";
                      }
                      return ret.join("");
                      }
                      
                      //get ASCII string, with escape chars, from unsigned char (byte) array
                      function getStrRepr(array) {
                      var ret = [], a = array;
                      for (var i=0; i<a.length; i++) {
                      if        (a[i] == '\t'.charCodeAt(0)) {
                      ret[i] = "\\t";
                      } else if (a[i] == '\n'.charCodeAt(0)) {
                      ret[i] = "\\n";
                      } else if (a[i] == '\r'.charCodeAt(0)) {
                      ret[i] = "\\r";
                      } else if (a[i] == '\\'.charCodeAt(0)) {
                      ret[i] = "\\\\";
                      //printable
                      } else if (a[i] >= 0x20 && a[i] <= 0x7E) {
                      ret[i] = String.fromCharCode(a[i]);
                      //use \hex for all others
                      } else {
                      var hex = a[i].toString(16);
                      ret[i] = "\\"+(hex.length==1?"0":"")+hex; // eg. 0xab => \ab instead of \xab
                      }
                      }
                      return ret.join("");
                      }
                      
                      factory.toggleModal = function(action) {
                      //close the modal window if it's open, otherwise open it
                      if(factory.modalActivated)
                      {
                      factory.modalActivated = false;
                      if(action=='swipe')
                      {
                      document.getElementById('openModal').style.opacity = 0;
                      document.getElementById('openModal').style.pointerEvents = 'none';
                      }
                      else if (action=='process')
                      {
                      document.getElementById('openModalProcessing').style.opacity = 0;
                      document.getElementById('openModalProcessing').style.pointerEvents = 'none';
                      }
                      }
                      else
                      {
                      factory.modalActivated = true;
                      if(action=='swipe')
                      {
                      document.getElementById('openModal').style.opacity = 1;
                      document.getElementById('openModal').style.pointerEvents = 'auto';
                      }
                      else if (action=='process')
                      {
                      document.getElementById('openModalProcessing').style.opacity = 1;
                      document.getElementById('openModalProcessing').style.pointerEvents = 'auto';
                      }
                      }
                      }
                      
                      factory.cancelModal = function(action) {
                      if(action=='swipe')
                      {
                      document.getElementById('openModal').style.opacity = 0;
                      document.getElementById('openModal').style.pointerEvents = 'none';
                      }
                      else if (action=='process')
                      {
                      
                      document.getElementById('openModalProcessing').style.opacity = 0;
                      document.getElementById('openModalProcessing').style.pointerEvents = 'none';
                      }
                      }
                      
                      
                      
                      return factory;
                      
                      }]).
factory('dbService', ['$q', function($q) {
                      
                      var factory = {};
                      
                      factory.database = window.openDatabase("dbMerchantApp", "1.0", "Merchant App DB",1000000);
                      
                      //viewOrders page
                      factory.queryDB = function(sqlString) {
                      var monthNames = [ "Jan", "Feb", "March", "April", "May", "June","July", "Aug", "Sept", "Oct", "Nov", "Dec" ];
                      var deferred = $q.defer();
                      factory.database.transaction(function(tx) {
                                                   tx.executeSql(sqlString, [], function(tx,results) {
                                                                 var orders = [];
                                                                 for(var i = 0;i<results.rows.length;i++)
                                                                 {
                                                                 var orderDate = new Date(results.rows.item(i).time);
                                                                 orders.push({
                                                                             id:results.rows.item(i).id,
                                                                             orderId:results.rows.item(i).orderId,
                                                                             customerName:results.rows.item(i).customerName,
                                                                             subTotal:results.rows.item(i).subTotal,
                                                                             time:results.rows.item(i).time,
                                                                             humanTime:monthNames[orderDate.getMonth()] + ' ' + orderDate.getDate() + ', ' + orderDate.getFullYear()
                                                                             });
                                                                 }
                                                                 
                                                                 deferred.resolve(orders)
                                                                 },
                                                                 factory.errorCB);
                                                   },
                                                   factory.errorCB, null);	
                      return deferred.promise;
                      }
                      
                      //orderDetails page
                      factory.queryDB2 = function(sqlString) {
                      var monthNames = [ "Jan", "Feb", "March", "April", "May", "June","July", "Aug", "Sept", "Oct", "Nov", "Dec" ];
                      var cardActions = [ "Sale", "Pre-Auth", "Post-Auth", "Refund" ];
                      var deferred = $q.defer();
                      factory.database.transaction(function(tx) {
                                                   tx.executeSql(sqlString, [], function(tx,results) {
                                                                 var transactions = [];
                                                                 for(var i = 0;i<results.rows.length;i++)
                                                                 {
                                                                 var orderDate = new Date(results.rows.item(i).time);
                                                                 transactions.push({
                                                                                   id:results.rows.item(i).id,
                                                                                   orderId:results.rows.item(i).orderId,
                                                                                   customerName:results.rows.item(i).customerName,
                                                                                   subTotal:results.rows.item(i).subTotal,
                                                                                   time:results.rows.item(i).time,
                                                                                   humanTime:monthNames[orderDate.getMonth()] + ' ' + orderDate.getDate() + ', ' + orderDate.getFullYear(),
                                                                                   phone:results.rows.item(i).phone,
                                                                                   email:results.rows.item(i).email,
                                                                                   address:results.rows.item(i).address,
                                                                                   city:results.rows.item(i).city,
                                                                                   province:results.rows.item(i).province,
                                                                                   country:results.rows.item(i).country,
                                                                                   postal:results.rows.item(i).postal,
                                                                                   avsResponse:results.rows.item(i).avsResponse,
                                                                                   refNum:results.rows.item(i).refNum,
                                                                                   cvvResult:results.rows.item(i).cvvResult,
                                                                                   notes:results.rows.item(i).notes,
                                                                                   action:cardActions[results.rows.item(i).action],
                                                                                   status:results.rows.item(i).status
                                                                                   });
                                                                 }
                                                                 
                                                                 deferred.resolve(transactions)
                                                                 },
                                                                 factory.errorCB);
                                                   },
                                                   factory.errorCB, null);	
                      return deferred.promise;
                      }
                      
                      factory.newPurchase = function(sqlString,order)
                      {
                      var deferred = $q.defer();
                      factory.database.transaction(function(tx) {
                                                   tx.executeSql(sqlString, [order.orderId,order.customerName,order.email,order.city,order.phone,order.province,order.country,order.address,order.postal,order.authAmount,order.time,order.notes,order.avsResponse,order.refNum,order.cvvResult], 
                                                                 function() { deferred.resolve(true) },
                                                                 factory.errorCB )
                                                   },
                                                   function() { navigator.notification.alert('Database error: Insert sale failed.',null,'Oops','Continue'); },
                                                   null);
                      return deferred.promise;
                      }
                      
                      factory.newTransaction = function(sqlString,order)
                      {
                      var deferred = $q.defer();
                      factory.database.transaction(function(tx) {
                                                   tx.executeSql(sqlString, [order.orderId,order.authAmount,order.time,order.cardAction,order.status], 
                                                                 function() { deferred.resolve(true) },
                                                                 function() { deferred.resolve(false) } )
                                                   },
                                                   function() { navigator.notification.alert('Database error: Insert transaction failed.',null,'Oops','Continue'); },
                                                   null);
                      return deferred.promise;
                      }
                      
                      
                      
                      factory.querySuccess = function(tx, results, deferred) {
                      deferred.resolve(results);
                      //updateTable(resultSet);
                      }
                      
                      factory.errorCB = function(tx, err) {
                      navigator.notification.alert('Error processing SQL: ' + err.message,null,'Oops','Continue');
                      }
                      
                      return factory;
                      
                      }])
.factory('ajaxService', ['$q','myService', function($q,myService) {
                         
                         var factory = {};
						 
						 factory.purchaseRequest = function(xmlString,isLive)
                         {
						 
						 if(isLive)
						 {
							var submitUrl = "https://secure.psigate.com:7934/Messenger/XMLMessenger";
						 }
						 else
						 {
							var submitUrl = "https://dev.psigate.com:7989/Messenger/XMLMessenger";
						 }
                         var deferred = $q.defer();
                         $.ajax({ 
                                type: "POST",
                                url: submitUrl,
                                data: { "orderXML":xmlString },
                                crossDomain: true,
                                dataType: "xml",
								async: false,
                                error: function() { navigator.notification.alert('Error: Server did not respond, check your internet connection.',null,'Oops','Continue');myService.toggleModal('process');},
                                success: function(response) { deferred.resolve(response); }
                                });
                         return deferred.promise;
                         }
                         
                         
                         return factory;
                         
                         }]);