
var unimag = {};

(function(){

// ----------------------------------------------------------------------------------
// unimag
// ----------------------------------------------------------------------------------
function unimagModule(){
  var um = {};

  //-----------------------------------------------------------------
  //activation
  //-----------------------------------------------------------------
  um.NotifEnum = {
    Attach     :"Attach"    ,
    Detach     :"Detach"    ,
    Connect    :"Connect"   ,
    Disconnect :"Disconnect",
  };
 
  var isSDKActive = false;
 
  um.isSDKActive = function() {
    return isSDKActive;
  };
 
  um.activateSDK = function(notifCallback) {
      isSDKActive = true;
      cordova.exec(notifCallback, null, "CDVUniMag", "activateSDK", []);
  };

  um.deactivateSDK = function() {
      isSDKActive = false;
      cordova.exec(null, null, "CDVUniMag", "deactivateSDK", []);
  };
  
  //-----------------------------------------------------------------
  //get status
  //-----------------------------------------------------------------
  um.isSDKConfigured   = function (valueCallback) {
    if (!isSDKActive) return;
    valueCallback(true); //iOS uniMag SDK is always configured
  };
  um.isReaderAttached  = function (valueCallback) {
    if (!isSDKActive) return;
    cordova.exec(valueCallback, null, "CDVUniMag", "isReaderAttached" , []);
  };
  um.isReaderConnected = function (valueCallback) {
    if (!isSDKActive) return;
    cordova.exec(valueCallback, null, "CDVUniMag", "isReaderConnected", []);
  };
  um.getRunningTask    = function (valueCallback) {
    if (!isSDKActive) return;
    cordova.exec(valueCallback, null, "CDVUniMag", "getRunningTask"   , []);
  };
  
    //start
  function getTaskCallbackWrapper(taskCallback) {
    return function(dict) {
      taskCallback(dict.taskEnum, dict.taskNotifEnum, dict.info || {});
    };
  }
  
  /**
  var example_taskCallback = function(taskEnum, taskNotifEnum, info) {};
  */
  um.startTaskConnect      = function (taskCallback) {
    if (!isSDKActive) return;
    cordova.exec(getTaskCallbackWrapper(taskCallback), function(err) { alert(error);}, "CDVUniMag", "startTaskConnect"    , []);
  };
  um.startTaskSwipe        = function (taskCallback) {
    if (!isSDKActive) return;
    cordova.exec(getTaskCallbackWrapper(taskCallback), function(err) { alert(error);}, "CDVUniMag", "startTaskSwipe"      , []);
  };
  
  //-----------------------------------------------------------------
  //start and stop task
  //-----------------------------------------------------------------
  //types
  um.TaskEnum = {
    Connect         :"Connect"    ,
    Swipe           :"Swipe"      ,
    SendCommand     :"SendCommand",
  };
  um.TaskNotifEnum = {
    Started         :"Started"    ,
    StartFailed     :"StartFailed",
    Update          :"Update"     ,
    Stopped         :"Stopped"    ,
  };
  
  
  //stop
  um.stopTask = function() {
    //if (!isSDKActive) return;
    cordova.exec(null, null, "CDVUniMag", "stopTask", []);
  };
  
  
    return um;
}

//export
window.unimag = unimagModule();

}());